/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.96 Revision 1.119
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.96 2005/12/08 12:16:12 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.119 2007/05/12 11:45:51 vapier Exp $
4 4#
5# Maintainer: toolchain@gentoo.org
5 6
6# need access to emktemp() 7# need access to emktemp()
7inherit eutils toolchain-funcs multilib 8inherit eutils toolchain-funcs multilib
8 9
9# 10#
19# 20#
20#### replace-cpu-flags <old.cpus> <new.cpu> ### 21#### replace-cpu-flags <old.cpus> <new.cpu> ###
21# Replace march/mcpu flags that specify <old.cpus> 22# Replace march/mcpu flags that specify <old.cpus>
22# with flags that specify <new.cpu> 23# with flags that specify <new.cpu>
23# 24#
24#### is-flag <flag> #### 25#### is-flag[q] <flag> ####
25# Returns "true" if flag is set in C[XX]FLAGS 26# Returns "true" if flag is set in C[XX]FLAGS
26# Matches only complete a flag 27# Matches only complete a flag
28# q version sets return code but doesn't echo
29#
30#### is-ldflag[q] <flag> ####
31# Returns "true" if flag is set in LDFLAGS
32# Matches only complete a flag
33# q version sets return code but doesn't echo
27# 34#
28#### strip-flags #### 35#### strip-flags ####
29# Strip C[XX]FLAGS of everything except known 36# Strip C[XX]FLAGS of everything except known
30# good options. 37# good options.
31# 38#
49# Add extra flags to your current LDFLAGS 56# Add extra flags to your current LDFLAGS
50# 57#
51#### filter-ldflags <flags> #### 58#### filter-ldflags <flags> ####
52# Remove particular flags from LDFLAGS 59# Remove particular flags from LDFLAGS
53# Matches only complete flags 60# Matches only complete flags
54#
55#### fstack-flags ####
56# hooked function for hardened gcc that appends
57# -fno-stack-protector to {C,CXX,LD}FLAGS
58# when a package is filtering -fstack-protector, -fstack-protector-all
59# notice: modern automatic specs files will also suppress -fstack-protector-all
60# when only -fno-stack-protector is given
61# 61#
62#### bindnow-flags #### 62#### bindnow-flags ####
63# Returns the flags to enable "now" binding in the current selected linker. 63# Returns the flags to enable "now" binding in the current selected linker.
64# 64#
65################ DEPRECATED functions ################ 65################ DEPRECATED functions ################
90# Returns true if the compiler by default or with current CFLAGS 90# Returns true if the compiler by default or with current CFLAGS
91# generates stack smash protections for most vulnerable functions 91# generates stack smash protections for most vulnerable functions
92# 92#
93 93
94# C[XX]FLAGS that we allow in strip-flags 94# C[XX]FLAGS that we allow in strip-flags
95# Note: shell globs and character lists are allowed
95setup-allowed-flags() { 96setup-allowed-flags() {
96 if [[ -z ${ALLOWED_FLAGS} ]] ; then 97 if [[ -z ${ALLOWED_FLAGS} ]] ; then
97 export ALLOWED_FLAGS="-pipe" 98 export ALLOWED_FLAGS="-pipe"
98 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune" 99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all" 100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-bounds-checking" 101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking"
101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-pie -fno-unit-at-a-time" 102 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
102 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g0 -g1 -g2 -g3 -ggdb -ggdb0 -ggdb1 -ggdb2 -ggdb3" 103 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
104 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
103 fi 105 fi
104 # allow a bunch of flags that negate features / control ABI 106 # allow a bunch of flags that negate features / control ABI
105 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all" 107 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
108 -fno-strict-aliasing -fno-bounds-checking"
106 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \ 109 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
107 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \ 110 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
108 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \ 111 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
109 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \ 112 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
110 -mieee -mieee-with-inexact \ 113 -mieee -mieee-with-inexact -mschedule \
111 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \ 114 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
112 -mflat -mno-flat -mno-faster-structs -mfaster-structs \ 115 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
113 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \ 116 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
114 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias" 117 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
118 -msecure-plt -D*"
115 119
116 # C[XX]FLAGS that we are think is ok, but needs testing 120 # C[XX]FLAGS that we are think is ok, but needs testing
117 # NOTE: currently -Os have issues with gcc3 and K6* arch's 121 # NOTE: currently -Os have issues with gcc3 and K6* arch's
118 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 122 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
119 return 0 123 return 0
124}
125
126# inverted filters for hardened compiler. This is trying to unpick
127# the hardened compiler defaults.
128_filter-hardened() {
129 local f
130 for f in "$@" ; do
131 case "${f}" in
132 # Ideally we should only concern ourselves with PIE flags,
133 # not -fPIC or -fpic, but too many places filter -fPIC without
134 # thinking about -fPIE.
135 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
136 gcc-specs-pie || continue
137 is-flagq -nopie || append-flags -nopie;;
138 -fstack-protector)
139 gcc-specs-ssp || continue
140 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
141 -fstack-protector-all)
142 gcc-specs-ssp-to-all || continue
143 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
144 esac
145 done
146}
147
148# Remove occurrences of strings from variable given in $1
149# Strings removed are matched as globs, so for example
150# '-O*' would remove -O1, -O2 etc.
151_filter-var() {
152 local f x VAR VAL
153 declare -a new
154
155 VAR=$1
156 shift
157 eval VAL=\${${VAR}}
158 for f in ${VAL}; do
159 for x in "$@"; do
160 # Note this should work with globs like -O*
161 [[ ${f} == ${x} ]] && continue 2
162 done
163 eval new\[\${\#new\[@]}]=\${f}
164 done
165 eval export ${VAR}=\${new\[*]}
120} 166}
121 167
122filter-flags() { 168filter-flags() {
123 local x f fset 169 _filter-hardened "$@"
124 declare -a new_CFLAGS new_CXXFLAGS 170 _filter-var CFLAGS "$@"
125 171 _filter-var CPPFLAGS "$@"
126 for x in "$@" ; do 172 _filter-var CXXFLAGS "$@"
127 case "${x}" in
128 -fPIC|-fpic|-fPIE|-fpie|-pie)
129 append-flags `test_flag -fno-pie`;;
130 -fstack-protector|-fstack-protector-all)
131 fstack-flags;;
132 esac
133 done
134
135 for fset in CFLAGS CXXFLAGS; do
136 # Looping over the flags instead of using a global
137 # substitution ensures that we're working with flag atoms.
138 # Otherwise globs like -O* have the potential to wipe out the
139 # list of flags.
140 for f in ${!fset}; do
141 for x in "$@"; do
142 # Note this should work with globs like -O*
143 [[ ${f} == ${x} ]] && continue 2
144 done
145 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
146 done
147 eval export ${fset}=\${new_${fset}\[*]}
148 done
149
150 return 0 173 return 0
151} 174}
152 175
153filter-lfs-flags() { 176filter-lfs-flags() {
154 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments" 177 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
155 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 178 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
156} 179}
157 180
181append-cppflags() {
182 [[ -z $* ]] && return 0
183 export CPPFLAGS="${CPPFLAGS} $*"
184 return 0
185}
186
158append-lfs-flags() { 187append-lfs-flags() {
159 [[ -n $@ ]] && die "append-lfs-flags takes no arguments" 188 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
160 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 189 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
161} 190}
162 191
163append-flags() { 192append-flags() {
164 [[ -z $* ]] && return 0 193 [[ -z $* ]] && return 0
165 export CFLAGS="${CFLAGS} $*" 194 export CFLAGS="${CFLAGS} $*"
166 export CXXFLAGS="${CXXFLAGS} $*" 195 export CXXFLAGS="${CXXFLAGS} $*"
167 [ -n "`is-flag -fno-stack-protector`" -o \
168 -n "`is-flag -fno-stack-protector-all`" ] && fstack-flags
169 return 0 196 return 0
170} 197}
171 198
172replace-flags() { 199replace-flags() {
173 [[ $# != 2 ]] \ 200 [[ $# != 2 ]] \
195 222
196replace-cpu-flags() { 223replace-cpu-flags() {
197 local newcpu="$#" ; newcpu="${!newcpu}" 224 local newcpu="$#" ; newcpu="${!newcpu}"
198 while [ $# -gt 1 ] ; do 225 while [ $# -gt 1 ] ; do
199 # quote to make sure that no globbing is done (particularly on 226 # quote to make sure that no globbing is done (particularly on
200 # ${oldcpu} prior to calling replace-flags 227 # ${oldcpu}) prior to calling replace-flags
201 replace-flags "-march=${1}" "-march=${newcpu}" 228 replace-flags "-march=${1}" "-march=${newcpu}"
202 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}" 229 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
203 replace-flags "-mtune=${1}" "-mtune=${newcpu}" 230 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
204 shift 231 shift
205 done 232 done
206 return 0 233 return 0
207} 234}
208 235
236_is_flagq() {
237 local x
238 for x in ${!1} ; do
239 [[ ${x} == $2 ]] && return 0
240 done
241 return 1
242}
243
244is-flagq() {
245 [[ -n $2 ]] && die "Usage: is-flag <flag>"
246 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
247}
248
209is-flag() { 249is-flag() {
210 local x 250 is-flagq "$@" && echo true
251}
211 252
212 for x in ${CFLAGS} ${CXXFLAGS} ; do 253is-ldflagq() {
213 # Note this should work with globs like -mcpu=ultrasparc* 254 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
214 if [[ ${x} == ${1} ]]; then 255 _is_flagq LDFLAGS $1
215 echo true 256}
216 return 0 257
217 fi 258is-ldflag() {
218 done 259 is-ldflagq "$@" && echo true
219 return 1
220} 260}
221 261
222filter-mfpmath() { 262filter-mfpmath() {
223 local orig_mfpmath new_math prune_math 263 local orig_mfpmath new_math prune_math
224 264
225 # save the original -mfpmath flag 265 # save the original -mfpmath flag
226 orig_mfpmath="`get-flag -mfpmath`" 266 orig_mfpmath=$(get-flag -mfpmath)
227 # get the value of the current -mfpmath flag 267 # get the value of the current -mfpmath flag
228 new_math=" `get-flag mfpmath | tr , ' '` " 268 new_math=$(get-flag mfpmath)
269 new_math=" ${new_math//,/ } "
229 # figure out which math values are to be removed 270 # figure out which math values are to be removed
230 prune_math="" 271 prune_math=""
231 for prune_math in "$@" ; do 272 for prune_math in "$@" ; do
232 new_math="${new_math/ ${prune_math} / }" 273 new_math=${new_math/ ${prune_math} / }
233 done 274 done
234 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 275 new_math=$(echo ${new_math})
276 new_math=${new_math// /,}
235 277
236 if [ -z "${new_math}" ] ; then 278 if [[ -z ${new_math} ]] ; then
237 # if we're removing all user specified math values are 279 # if we're removing all user specified math values are
238 # slated for removal, then we just filter the flag 280 # slated for removal, then we just filter the flag
239 filter-flags ${orig_mfpmath} 281 filter-flags ${orig_mfpmath}
240 else 282 else
241 # if we only want to filter some of the user specified 283 # if we only want to filter some of the user specified
311test-flag-CC() { test-flag-PROG "CC" "$1"; } 353test-flag-CC() { test-flag-PROG "CC" "$1"; }
312 354
313# Returns true if C++ compiler support given flag 355# Returns true if C++ compiler support given flag
314test-flag-CXX() { test-flag-PROG "CXX" "$1"; } 356test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
315 357
316test-flags() { 358test-flags-PROG() {
359 local comp=$1
360 local flags
317 local x 361 local x
318 362
363 shift
364
365 [[ -z ${comp} ]] && return 1
366
367 x=""
319 for x in "$@" ; do 368 for x in "$@" ; do
320 test-flag-CC "${x}" || return 1 369 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
321 done 370 done
322 371
323 echo "$@" 372 echo "${flags}"
324 373
325 return 0 374 # Just bail if we dont have any flags
375 [[ -n ${flags} ]]
326} 376}
377
378# Returns (echo's) the given flags supported by the C compiler
379test-flags-CC() { test-flags-PROG "CC" "$@"; }
380
381# Returns (echo's) the given flags supported by the C++ compiler
382test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
383
384# Short-hand that should hopefully work for both C and C++ compiler, but
385# its really only present due to the append-flags() abomination.
386test-flags() { test-flags-CC "$@"; }
327 387
328# Depriciated, use test-flags() 388# Depriciated, use test-flags()
329test_flag() { 389test_flag() {
330 ewarn "test_flag: deprecated, please use test-flags()!" >/dev/stderr 390 ewarn "test_flag: deprecated, please use test-flags()!" >&2
331 391
332 test-flags "$@" 392 test-flags-CC "$@"
333} 393}
334 394
335test_version_info() { 395test_version_info() {
336 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then 396 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
337 return 0 397 return 0
339 return 1 399 return 1
340 fi 400 fi
341} 401}
342 402
343strip-unsupported-flags() { 403strip-unsupported-flags() {
344 local x NEW_CFLAGS NEW_CXXFLAGS 404 export CFLAGS=$(test-flags-CC ${CFLAGS})
345 405 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
346 for x in ${CFLAGS} ; do
347 NEW_CFLAGS="${NEW_CFLAGS} $(test-flags ${x})"
348 done
349 for x in ${CXXFLAGS} ; do
350 NEW_CXXFLAGS="${NEW_CXXFLAGS} $(test-flags ${x})"
351 done
352
353 export CFLAGS=${NEW_CFLAGS}
354 export CXXFLAGS=${NEW_CXXFLAGS}
355} 406}
356 407
357get-flag() { 408get-flag() {
358 local f findflag="$1" 409 local f findflag="$1"
359 410
371 return 1 422 return 1
372} 423}
373 424
374# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs 425# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
375has_hardened() { 426has_hardened() {
376 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" \ 427 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
377 >/dev/stderr 428
378
379 test_version_info Hardened && return 0 429 test_version_info Hardened && return 0
380 # The specs file wont exist unless gcc has GCC_SPECS support 430 # The specs file wont exist unless gcc has GCC_SPECS support
381 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]] 431 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
382} 432}
383 433
384# DEPRECATED - use gcc-specs-pie from toolchain-funcs 434# DEPRECATED - use gcc-specs-pie from toolchain-funcs
385# indicate whether PIC is set 435# indicate whether PIC is set
386has_pic() { 436has_pic() {
387 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >/dev/stderr 437 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
388 438
389 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \ 439 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
390 ${CFLAGS/-fpic} != ${CFLAGS} || \ 440 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
391 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __PIC__) ]] 441 gcc-specs-pie
392} 442}
393 443
394# DEPRECATED - use gcc-specs-pie from toolchain-funcs 444# DEPRECATED - use gcc-specs-pie from toolchain-funcs
395# indicate whether PIE is set 445# indicate whether PIE is set
396has_pie() { 446has_pie() {
397 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >/dev/stderr 447 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
398 448
399 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \ 449 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
400 ${CFLAGS/-fpie} != ${CFLAGS} || \ 450 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
401 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __PIE__) || \ 451 gcc-specs-pie
402 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __PIC__) ]]
403 # test PIC while waiting for specs to be updated to generate __PIE__
404} 452}
405 453
406# DEPRECATED - use gcc-specs-ssp from toolchain-funcs 454# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
407# indicate whether code for SSP is being generated for all functions 455# indicate whether code for SSP is being generated for all functions
408has_ssp_all() { 456has_ssp_all() {
409 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >/dev/stderr 457 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
410 458
411 # note; this matches only -fstack-protector-all 459 # note; this matches only -fstack-protector-all
412 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \ 460 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
413 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \ 461 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
414 gcc-specs-ssp 462 gcc-specs-ssp-all
415} 463}
416 464
417# DEPRECATED - use gcc-specs-ssp from toolchain-funcs 465# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
418# indicate whether code for SSP is being generated 466# indicate whether code for SSP is being generated
419has_ssp() { 467has_ssp() {
420 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >/dev/stderr 468 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
421 469
422 # note; this matches both -fstack-protector and -fstack-protector-all 470 # note; this matches both -fstack-protector and -fstack-protector-all
423 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \ 471 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
424 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \ 472 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
425 gcc-specs-ssp 473 gcc-specs-ssp
426} 474}
428has_m64() { 476has_m64() {
429 # this doesnt test if the flag is accepted, it tests if the flag 477 # this doesnt test if the flag is accepted, it tests if the flag
430 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 478 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
431 # please dont replace this function with test_flag in some future 479 # please dont replace this function with test_flag in some future
432 # clean-up! 480 # clean-up!
433 481
434 local temp="$(emktemp)" 482 local temp="$(emktemp)"
435 echo "int main() { return(0); }" > "${temp}".c 483 echo "int main() { return(0); }" > "${temp}".c
436 MY_CC=$(tc-getCC) 484 MY_CC=$(tc-getCC)
437 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1 485 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
438 local ret=$? 486 local ret=$?
458 [[ ${ret} != 1 ]] && return 0 506 [[ ${ret} != 1 ]] && return 0
459 return 1 507 return 1
460} 508}
461 509
462replace-sparc64-flags() { 510replace-sparc64-flags() {
463 local SPARC64_CPUS="ultrasparc v9" 511 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
464 512
465 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then 513 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
466 for x in ${SPARC64_CPUS}; do 514 for x in ${SPARC64_CPUS}; do
467 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 515 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
468 done 516 done
469 else 517 else
470 for x in ${SPARC64_CPUS}; do 518 for x in ${SPARC64_CPUS}; do
471 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 519 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
472 done 520 done
473 fi 521 fi
474 522
475 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then 523 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
476 for x in ${SPARC64_CPUS}; do 524 for x in ${SPARC64_CPUS}; do
477 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 525 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
478 done 526 done
479 else 527 else
480 for x in ${SPARC64_CPUS}; do 528 for x in ${SPARC64_CPUS}; do
481 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 529 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
482 done 530 done
483 fi 531 fi
484 532
485 export CFLAGS CXXFLAGS 533 export CFLAGS CXXFLAGS
486} 534}
487 535
488append-ldflags() { 536append-ldflags() {
537 [[ -z $* ]] && return 0
489 export LDFLAGS="${LDFLAGS} $*" 538 export LDFLAGS="${LDFLAGS} $*"
490 return 0 539 return 0
491} 540}
492 541
542# Remove flags from LDFLAGS - it's up to the ebuild to filter
543# CFLAGS and CXXFLAGS via filter-flags if they need to.
493filter-ldflags() { 544filter-ldflags() {
494 local x 545 _filter-var LDFLAGS "$@"
546 return 0
547}
495 548
496 # we do this fancy spacing stuff so as to not filter 549# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
497 # out part of a flag ... we want flag atoms ! :D 550# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
498 LDFLAGS=" ${LDFLAGS} " 551# to gcc where it needs the '-Wl,'.
552raw-ldflags() {
553 local x input="$@"
554 [[ -z ${input} ]] && input=${LDFLAGS}
555 set --
499 for x in "$@" ; do 556 for x in ${input} ; do
500 LDFLAGS=${LDFLAGS// ${x} / } 557 x=${x#-Wl,}
558 set -- "$@" ${x//,/ }
501 done 559 done
502 [[ -z ${LDFLAGS// } ]] \ 560 echo "$@"
503 && LDFLAGS="" \
504 || LDFLAGS=${LDFLAGS:1:${#LDFLAGS}-2}
505 export LDFLAGS
506 return 0
507}
508
509fstack-flags() {
510 if gcc-specs-ssp; then
511 [ -z "`is-flag -fno-stack-protector`" ] &&
512 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`"
513 fi
514 return 0
515}
516
517# This is thanks to great work from Paul de Vrieze <gentoo-user@devrieze.net>,
518# bug #9016. Also thanks to Jukka Salmi <salmi@gmx.net> (bug #13907) for more
519# fixes.
520#
521# Export CFLAGS and CXXFLAGS that are compadible with gcc-2.95.3
522gcc2-flags() {
523 if [[ $(tc-arch) == "x86" || $(tc-arch) == "amd64" ]] ; then
524 CFLAGS=${CFLAGS//-mtune=/-mcpu=}
525 CXXFLAGS=${CXXFLAGS//-mtune=/-mcpu=}
526 fi
527
528 replace-cpu-flags k6-{2,3} k6
529 replace-cpu-flags athlon{,-{tbird,4,xp,mp}} i686
530
531 replace-cpu-flags pentium-mmx i586
532 replace-cpu-flags pentium{2,3,4} i686
533
534 replace-cpu-flags ev6{7,8} ev6
535
536 export CFLAGS CXXFLAGS
537} 561}
538 562
539# Gets the flags needed for "NOW" binding 563# Gets the flags needed for "NOW" binding
540bindnow-flags() { 564bindnow-flags() {
541 case $($(tc-getLD) -v 2>&1 </dev/null) in 565 case $($(tc-getLD) -v 2>&1 </dev/null) in
550 echo "-Wl,-z,now" ;; 574 echo "-Wl,-z,now" ;;
551 esac 575 esac
552 ;; 576 ;;
553 esac 577 esac
554} 578}
579
580
581# Some tests for when we screw with things and want to make
582# sure we didn't break anything
583#TESTS() {
584# CFLAGS="-a -b -c=1"
585# CXXFLAGS="-x -y -z=2"
586# LDFLAGS="-l -m -n=3"
587#
588# die() { exit 1; }
589# (is-flag 1 2 3) && die
590# (is-ldflag 1 2 3) && die
591#
592# is-flagq -l && die
593# is-ldflagq -a && die
594# is-flagq -a || die
595# is-flagq -x || die
596# is-ldflagq -n=* || die
597# is-ldflagq -n && die
598#
599# strip-unsupported-flags
600# [[ ${CFLAGS} == "-c=1" ]] || die
601# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
602#
603# echo "All tests pass"
604#}
605#TESTS

Legend:
Removed from v.1.96  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20